<template>
    <Selector
        :placeholder="placeholder"
        :items="prepItems"
        text="name"
        :name="fieldName"
        v-model="currentItem"
    />
</template>

<script>
import Selector from "@/components/Selector";
export default {
    name: "FilterSelector",
    components: { Selector },
    props: {
        placeholder: String,
        items: { type: Array, default: () => [] },
        name: String,
        fieldName: { type: String, default: "id" },
        value: [String, Number],
    },
    computed: {
        currentItem: {
            get() {
                return this.value;
            },
            set(value) {
                this.$emit("input", value || null);
            },
        },
        prepItems() {
            return [{ id: null, name: "-" }, ...this.items];
        },
    },
    watch: {
        currentItem(value) {
            if (
                ![
                    this.$route.query[this.name],
                    Number(this.$route.query[this.name]),
                ].includes(value)
            )
                this.$router.push({
                    query: { ...this.$route.query, [this.name]: value },
                });
        },
        "$route.query": {
            immediate: true,
            deep: true,
            handler(value) {
                this.currentItem = value[this.name]
                    ? Number(value[this.name]) !== this.currentItem
                        ? Number(value[this.name])
                        : this.currentItem
                    : null;
            },
        },
    },
};
</script>

<style scoped></style>
